import { isNumber, isFunction, pick, } from '@handie/runtime-core';
function getPickerOption(value, config, record) {
    const { disableDate, showNow } = pick(config, ['disableDate', 'showNow']);
    const options = { showNow };
    if (isFunction(disableDate)) {
        options.disableDate = (date) => disableDate(value, date, record);
    }
    return options;
}
function getNumberInputProps(vueInst) {
    const props = {
        value: vueInst.value,
        placeholder: vueInst.getPlaceholder(),
        disabled: vueInst.disabled,
        prefix: vueInst.config.prefix,
        suffix: vueInst.config.suffix,
    };
    if (vueInst.showValidationRulesAsNative) {
        const { min, max } = vueInst.field;
        if (isNumber(min)) {
            props.min = min;
        }
        if (isNumber(max)) {
            props.max = max;
        }
    }
    return props;
}
function getStringInputtableControlProps(vueInst, filterWidget = false) {
    const props = {
        value: vueInst.value,
        placeholder: vueInst.getPlaceholder(),
    };
    if (filterWidget !== true) {
        props.disabled = vueInst.disabled;
    }
    if (vueInst.showValidationRulesAsNative) {
        const { min, max } = (filterWidget === true ? vueInst.filter : vueInst.field);
        if (isNumber(min)) {
            props.minLength = min;
        }
        if (isNumber(max)) {
            props.maxLength = max;
        }
    }
    return props;
}
export { getPickerOption, getNumberInputProps, getStringInputtableControlProps };
