import { __decorate } from "tslib";
import { Component } from 'vue-property-decorator';
import { getControl } from 'handie-vue';
import { DateFilterStructuralWidget } from 'handie-vue/dist/widgets';
import { getPickerOption } from '../../../../utils';
let DateRangeDateFilterWidget = class DateRangeDateFilterWidget extends DateFilterStructuralWidget {
    handleRangeChange(_, dates) {
        this.onRangeChange(dates);
        if (this.searchImmediately) {
            this.$$search.submit();
        }
    }
    render(h) {
        return h(getControl('DateRangePicker'), {
            props: {
                value: this.getRangeValue(),
                placeholder: this.getRangePlaceholders(),
                format: this.getDisplayFormat(),
                separator: this.getSeparator(),
                pickerOption: getPickerOption(this.getRangeValue(), this.config, this.$$search.getValue()),
            },
            on: { change: this.handleRangeChange },
        });
    }
    created() {
        this.setDefaultFormat(this.getCommonBehavior('filter.dateFormat'));
    }
};
DateRangeDateFilterWidget = __decorate([
    Component
], DateRangeDateFilterWidget);
export default DateRangeDateFilterWidget;
